--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_mem.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_mem.h	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,509 @@
+/* Name: mausb_mem.h 
+ * Description: Header for mausb_mem.c. Needed do make calls to 
+ * functions defined in mausb_mem.c. 
+ * 
+ * This file is provided under a dual BSD/GPLv2 license. When using or 
+ * redistributing this file, you may do so under either license. 
+ * 
+ * GPL LICENSE SUMMARY 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * This program is free software; you can redistribute it and/or modify it 
+ * under the terms of version 2 of the GNU General Public License as published 
+ * by the Free Software Foundation. 
+ * 
+ * This program is distributed in the hope that it will be useful, but 
+ * WITHOUT ANY WARRANTY; without even the implied warranty of 
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
+ * General Public License for more details. 
+ * 
+ * Contact Information: 
+ * Sean Stalley, sean.stalley [at] intel 
+ * Stephanie Wallick, stephanie.s.wallick [at] intel 
+ * 2111 NE 25th Avenue 
+ * Hillsboro, Oregon 97124 
+ * 
+ * BSD LICENSE 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * Redistribution and use in source and binary forms, with or without 
+ * modification, are permitted provided that the following conditions 
+ * are met: 
+ * 
+ * Redistributions of source code must retain the above copyright 
+ notice, this list of conditions and the following disclaimer. 
+ * Redistributions in binary form must reproduce the above copyright 
+ notice, this list of conditions and the following disclaimer in 
+ the documentation and/or other materials provided with the 
+ distribution. 
+ * Neither the name of Intel Corporation nor the names of its 
+ contributors may be used to endorse or promote products derived 
+ from this software without specific prior written permission. 
+ 
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
+ * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
+ * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
+ * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
+ */ 
+ 
+#ifndef __MAUSB_MEM_H 
+#define __MAUSB_MEM_H 
+ 
+#include "mausb_state.h" 
+#include "mausb_pkt.h" 
+#include "mausb_msapi.h" 
+ 
+#include <linux/usb.h> 
+#include <linux/usb/hcd.h> 
+#include <linux/usb/gadget.h> 
+#include <linux/timer.h> 
+ 
+#ifdef DEBUG 
+#define mamem_dbg(format, arg...) \ 
+ printk(KERN_DEBUG format, ##arg) 
+#else 
+#define mamem_dbg(format, arg...) 
+#endif 
+ 
+#define mamem_warn(format, arg...) \ 
+ printk(KERN_WARNING format, ##arg) 
+ 
+#define mamem_err(format, arg...) \ 
+ printk(KERN_ERR format, ##arg) 
+ 
+/* forward declarations */ 
+struct mausb_urb; 
+struct mausb_pkt; 
+struct mausb_host_ep; 
+ 
+/** 
+ * mausb_mgmt - MAUSB management datastrucure 
+ * 
+ * Contains all the data necessary to handle management packets. 
+ * 
+ * @req_list: List of all currently pending management requests for 
+ * this device. 
+ * @token: The value of the token field in the most recently sent 
+ * management request. 
+ * @tx_pair: Indicates where management packets should be sent. 
+ * 
+ * The following variables are to store common management packet fields: 
+ * 
+ * @hub_dev_handle: Device Handle of the MAUSB Dock hub. used for 
+ * USBDevHandleReq packets. 
+ * @ma_dev_lock: The spinlock which protects the management data in this 
+ * struct. 
+ * @req_switch: The host or devices request switch. It accepts an 
+ * incoming request, makes the necessary calls, and 
+ * returns a partially completed response (it fills the 
+ * response type, status & any data fields specific to 
+ * that response). the remainder of the fields are 
+ * completed by mausb_rx_mgmt_req. 
+ */ 
+struct mausb_mgmt { 
+ struct list_head req_list; 
+ __u16 token:10; 
+ struct mausb_transfer_pair tx_pair; 
+ __u16 hub_dev_handle; 
+ spinlock_t *ma_dev_lock; 
+ int (*req_switch)(struct mausb_mgmt_pkt *req, 
+ struct mausb_mgmt_pkt *resp, struct mausb_mgmt *mgmt); 
+}; 
+ 
+/** 
+ * mausb_mgmt_req_list - MAUSB management request list entry 
+ * 
+ * An entry in the mausb_mgmt request linked list. 
+ * 
+ * @req_list: Pointers to other entries in the list. 
+ * @mgmt_req: The request management packet. 
+ * @mgmt_resp: The response management packet, set to NULL until a response 
+ * is received. 
+ * @resp_rcvd: An event triggered when the response is received. 
+ */ 
+struct mausb_mgmt_req_list { 
+ struct list_head req_list; 
+ 
+ struct mausb_pkt *mgmt_req; 
+ struct mausb_pkt *mgmt_resp; 
+ 
+ struct completion resp_rcvd; 
+}; 
+ 
+/** 
+ * Media Agnostic Session State 
+ * 
+ * Defines the current state of the session between the host & device. 
+ * Per MAUSB spec, sections 7.1 & 8.1.1. 
+ */ 
+enum mausb_session_state { 
+ MAUSB_SESSION_DOWN, 
+ MAUSB_SESSION_CONNECTING, 
+ MAUSB_SESSION_ACITVE, 
+ MAUSB_SESSION_INACTIVE 
+}; 
+ 
+/** 
+ * stores information returned in a CapResp packet 
+ */ 
+struct ma_capability { 
+ __u16 num_ep; 
+ __u8 num_dev; 
+ __u8 num_stream:5; 
+ __u8 dev_type:3; 
+ __u16 max_tx_reqs; 
+ __u16 max_mgmt_reqs:12; 
+}; 
+ 
+/** 
+ * MA device data 
+ * 
+ * This structure is used to hold MA device-specific data 
+ * (i.e. one instance of this structure exists per MA device). 
+ * 
+ * @mgmt: Contains the data needed to keep track of the device's 
+ * management packets. 
+ * @dev_list: Stores a list of the devices connected to this HCD. 
+ * This includes any internal mausb data that exists on 
+ * a per-device, per-endpoint, or per-transfer basis. 
+ * @top_dev: The most upstream mausb device. Used to determine 
+ * where to send MA USB device management packets (such as 
+ * MAUSBDevSleepReq and MAUSBDevWakeReq). 
+ * @session_state: Defines the current state of the session between the 
+ * host and device. Per MAUSB spec, sections 7.1 & 8.1.1. 
+ * @ma_dev_addr: MA Device Address. Assigned by the host via a 
+ * MAUSBDevResetReq. 
+ * @mass_id: Media-Agnostic Service Set Identifier. Assigned by the 
+ * host via a MAUSBDevResetReq. 
+ * @ma_dev_lock: Spinlock for this device. This lock should be held 
+ * before accessing any data in this structure. 
+ * @ma_drv: Media agnostic driver interfaces. 
+ * @ms_drv: Media specific driver interfaces. 
+ * @ma_cap: Stores MA device info from CapResp packet fields. 
+ * @speed: Stores MA device info from speed capability descriptor. 
+ * @pout: Stores MA device info from P-managed OUT capability 
+ * descriptor. 
+ * @iso: Stores MA device info from isochronous capabilities 
+ * descriptor. 
+ * @synch: Stores MA device info from synchronization capabilities 
+ * descriptor. 
+ * @cont_id: Stores MA device info from container ID capability 
+ * descriptor. 
+ * @link_sleep: Stores MA device info from link sleep capability 
+ * descriptor. 
+ */ 
+struct ma_dev { 
+ struct mausb_mgmt mgmt; 
+ struct list_head dev_list; 
+ struct mausb_dev *top_dev; 
+ enum mausb_session_state session_state; 
+ __u8 ma_dev_addr:7; 
+ __u8 mass_id; 
+ spinlock_t ma_dev_lock; 
+ 
+ union { 
+ struct mausb_hcd *mhcd; 
+ struct mausb_udc *maudc; 
+ }; 
+ 
+ struct mausb_ma_drv ma_drv; 
+ struct mausb_ms_drv *ms_driver; 
+ 
+ struct ma_capability ma_cap; 
+ struct mausb_dev_cap_speed *speed; 
+ struct mausb_dev_cap_pout *pout; 
+ struct mausb_dev_cap_iso *iso; 
+ struct mausb_dev_cap_sync *sync; 
+ struct mausb_dev_cap_cont_id *cont_id; 
+ struct mausb_dev_cap_link_sleep *link_sleep; 
+}; 
+ 
+/** 
+ * MA USB device data 
+ * 
+ * This structure is used to hold device-pecific data 
+ * (i.e. one instance of this structure exists per usb device). 
+ * 
+ * @dev: A pointer to the kernel's usb device structure. Can be 
+ * used to uniquely identify a device. 
+ * @gadget: A pointer to the kernel's usb gadget structure. 
+ * @ma_dev: Pointer to parent ma_dev structure. 
+ * @ep_list: A linked list of all the endpoints for this device. 
+ * MAUSBDevHandleResp packet. 
+ * @dev_handle: MA USB device handle for this device 
+ * @dev_address: The usb device address. set by the ma_dev. 
+ * NOTE: this is not the same as the address given by 
+ * the kernel. 
+ * @dev_list: A linked list of all the devices in the HCD. 
+ * @dev_lock: Spinlock for this device. This lock should be held 
+ * before accessing any data in this structure. 
+ */ 
+struct mausb_dev { 
+ union { 
+ struct usb_device *dev; /* Host only */ 
+ struct usb_gadget *gadget; /* Device only */ 
+ }; 
+ struct ma_dev *ma_dev; 
+ struct list_head ep_list; 
+ __u16 dev_handle; 
+ __u8 dev_address; 
+ struct list_head dev_list; 
+ spinlock_t dev_lock; 
+}; 
+ 
+/** 
+ * MAUSB Endpoint Handle State Variables 
+ * 
+ * Defines the states for an MA USB Endpoint Handle. 
+ * 
+ * Per MAUSB spec, seciton 7.2 
+ * 
+ * Note: MAUSB_EP_HANDLE_DELETED is used to flag an endpoint for deletion 
+ * it is not per spec; endpoints in this state should not be used and 
+ * will be deleted in the next EPHandleDeleteReq. 
+ */ 
+enum mausb_ep_handle_state { 
+ MAUSB_EP_HANDLE_UNASSIGNED = 0, 
+ MAUSB_EP_HANDLE_ACTIVE, 
+ MAUSB_EP_HANDLE_INACTIVE, 
+ MAUSB_EP_HANDLE_HALTED, 
+ MAUSB_EP_HANDLE_DELETED 
+}; 
+ 
+/** 
+ * MA USB host-side endpoint data 
+ * 
+ * This structure is used to hold endpoint-specific data 
+ * (i.e. one instance of this structure exists per endpoint). 
+ * 
+ * The following data is protected by the devices's dev_lock: 
+ * 
+ * @ep: Used only by the host side. A pointer to the kernel's host-side 
+ * endpoint structure. Can be used to uniquely identify an 
+ * endpoint. Note: the HCD probably shouldn't read or write 
+ * anything from the usb_host_endpoint structure, since it belongs 
+ * to the kernel. 
+ * @dev_ep: Used only by the device side. A pointer to the kernel's 
+ * device-side endpoint structure. 
+ * @ep_list: A linked list of all the endpoints connected to the same 
+ * device. 
+ * 
+ * The following data is protected by the endpoint's ep_lock: 
+ * 
+ * @state: The MA USB state variables for this endpoint. Per 
+ * MA USB Spec, sections 5.4.1 and 5.5.2. 
+ * @active_transfer: Urb that maps to the transfer in progress. 
+ * @ep_handle: The endpoint handle to be used by packets for this 
+ * endpoint per MA USB Spec, section 6.2.1.5. 
+ * @ep_handle_state: Defines the states an Endpoint Handle can be in. 
+ * Per MA USB Spec, section 7.2. 
+ * @buffer: Buffer that holds data going to/from a host during 
+ * transfer. 
+ * @actual_length: Length of buffer. 
+ * @lman_support: For control or non-iso OUT endpoints. Indicates if 
+ * link-managed tranfers are supported. Not valid until 
+ * an EPHandleResp is received for this endpoint. 
+ * @control_dir: Control endpoints only; used to determine the direction 
+ * of the current transfer. 
+ * @ccu: The credit conumption unit, in bytes. Per MA USB Spec, 
+ * table 27. 
+ * @mausb_dev: The device the endpoint belongs to. 
+ * @urb_list: A linked list of all URBs pending for this endpoint. 
+ * URBs map one-to-one with MAUSB Transfers, so each entry 
+ * also represents an MA USB Transfer. 
+ * @usb_req_list: Only used on the device side. A linked list of all 
+ * usb_requests submitted to this endpoint. 
+ * @req_list: Head of list of created transferRequests and 
+ * transferAck packets. 
+ * @resp_list: Head of list of received transferResponses packets. 
+ * @ep_lock: Spinlock for this endpoint. This lock should be held 
+ * before accessing any data in this structure. 
+ * @timer: Endpoint timer structure, used to monitor transfer 
+ * timeouts. 
+ * @timeout_task: Thread used to perform packet resends after transfer 
+ * timeout. 
+ * @host_ep_wq: Work queue for timeout thread to wait on while sleeping. 
+ * @tx_timed_out: Used to flag when a timeout event has occured during 
+ * a transfer. 
+ * @tx_pair: Transfer pair for this endpoint. 
+ * @gadget: USB gadget associated with this endpoint. 
+ * @busy: True if this endpoint is busy, otherwise false. 
+ * @halted: 1 if endpoint is halted, otherwise 0. 
+ * @wedged: 1 if endpoint is wedged, otherwise 0. 
+ * @stream_en: 1 if streams are enabled for this endpoint, otherwise 0. 
+ * @max_pkt: Max packet size for this endpoint. 
+ */ 
+struct mausb_host_ep { 
+ 
+ struct usb_host_endpoint *ep; /* Host only */ 
+ struct usb_ep *dev_ep; /* Device only */ 
+ struct list_head ep_list; 
+ struct mausb_ep_state state; 
+ struct mausb_urb *active_transfer; 
+ struct mausb_ep_handle ep_handle; 
+ enum mausb_ep_handle_state ep_handle_state; 
+ void *buffer; 
+ u32 actual_length; 
+ bool lman_support; 
+ bool control_dir; 
+ u16 ccu; 
+ struct mausb_dev *mausb_dev; 
+ struct list_head urb_list; 
+ struct list_head *usb_req_list; 
+ struct list_head req_list; 
+ struct list_head resp_list; 
+ spinlock_t ep_lock; 
+ struct timer_list timer; 
+ struct task_struct *timeout_task; 
+ wait_queue_head_t host_ep_wq; 
+ bool tx_timed_out; 
+ struct mausb_transfer_pair tx_pair; 
+ struct usb_gadget *gadget; /* Device only */ 
+ bool busy; 
+ unsigned halted:1; 
+ unsigned wedged:1; 
+ unsigned stream_en:1; 
+ u16 max_pkt; 
+}; 
+ 
+/** 
+ * endpoint request structure - describes one I/O request 
+ * 
+ * @usb_ep: A device-side endpoint structure. 
+ * @queue: The list of all requests currently enqueued to this endpoint. 
+ */ 
+struct mausb_gadget_ep { 
+ struct usb_ep dev_ep; 
+ struct list_head usb_req_list; 
+}; 
+ 
+/** 
+ * MA USB urb structure 
+ * 
+ * Stores MAUSB-specific urb data. In our implementation, one urb from usb 
+ * core maps to exactly one MA USB transfer. When an urb is submitted, it 
+ * queues a new transfer. When a transfer is complete (or fails), the urb 
+ * is given back to the core. 
+ * 
+ * All data listed in this structure is protected by the ep_lock. 
+ * If you want to use any of this data, you need to be in posession 
+ * of this lock. 
+ * 
+ * @urb: Used only on the host side. The urb submitted to the 
+ * HCD by usbcore. 
+ * @usb_request_list: Used only on the device side. A pointer to the list of 
+ * msusb_requests for this endpoint. 
+ * @urb_list: Connects this mausb_urb with other mausb_urbs 
+ * queued to the same endpoint. 
+ * @ma_hcd_urb_list: Connects this urb to urbs queued to the same ma hcd. 
+ * @state: Current state of the transfer as defined in the 
+ * MA USB Spec. 
+ * @ep: The endpoint that the transfer belongs to. 
+ * @dev: The device that the transfer belongs to. 
+ * @transfer_size: Total number of bytes for transfer associated with urb. 
+ */ 
+struct mausb_urb { 
+ struct urb *urb; /* Host Only */ 
+ struct list_head *usb_request_list; /* Device Only */ 
+ struct list_head urb_list; 
+ struct list_head ma_hcd_urb_list; 
+ struct mausb_transfer_state state; 
+ struct mausb_host_ep *ep; 
+ struct mausb_dev *dev; 
+ unsigned int transfer_size; 
+}; 
+ 
+/** 
+ * endpoint request structure - describes one I/O request 
+ * 
+ * @req: The usb_request struct. Enqueuing a usb_request is 
+ * what triggers the creation of this struct. 
+ * @usb_req_list: List of all requests enqueued at this endpoint. 
+ */ 
+struct mausb_request { 
+ struct usb_request req; 
+ struct list_head usb_req_list; 
+}; 
+ 
+/* endpoint/device helper functions */ 
+struct mausb_host_ep *usb_to_ma_endpoint(struct usb_host_endpoint *ep); 
+int mausb_hcd_urb_count(struct mausb_hcd *mhcd); 
+ 
+#define MAUSB_ADD true 
+#define MAUSB_DEL false 
+#define MAUSB_DEV false 
+#define MAUSB_HOST true 
+#define MAUSB_OUT false 
+#define MAUSB_IN true 
+struct mausb_pkt *mausb_create_dp(int *status, struct mausb_urb *maurb, 
+ bool in, bool host, gfp_t memflags); 
+ 
+/* endpoint/device memory management functions */ 
+struct mausb_host_ep *mausb_state_to_ep(struct mausb_ep_state *state); 
+struct ma_dev *context_to_ma_dev(void *context); 
+struct mausb_hcd *mausb_host_ep_to_mahcd(struct mausb_host_ep *ep); 
+struct mausb_udc *mausb_host_ep_to_maudc(struct mausb_host_ep *ep); 
+struct mausb_dev *usb_dev_to_mausb_dev(struct usb_device *udev); 
+struct mausb_host_ep *mausb_find_ep_dev(struct usb_ep *dev_ep, 
+ struct mausb_dev *mausb_dev); 
+struct mausb_host_ep *mausb_find_ep_host(struct usb_host_endpoint *ep, 
+ struct mausb_dev *mausb_dev); 
+struct mausb_host_ep *mausb_find_ep_by_handle(struct mausb_ep_handle *handle, 
+ struct mausb_dev *mausb_dev); 
+struct mausb_host_ep *mausb_find_ep_from_handle(struct mausb_ep_handle handle, 
+ struct ma_dev *ma_dev); 
+struct mausb_pkt *mausb_pkt_from_ms_pkt_ma_dev(struct ms_pkt *ms_pkt, 
+ struct ma_dev *ma_dev, gfp_t mem_flags); 
+struct mausb_pkt *mausb_pkt_from_ms_pkt_ep(struct ms_pkt *ms_pkt, 
+ struct mausb_host_ep *ep, gfp_t mem_flags); 
+struct mausb_dev *mausb_find_dev(struct ma_dev *ma_dev, struct usb_device *dev, 
+ unsigned long *handle, struct usb_gadget *gadget); 
+struct mausb_dev *mausb_find_dev_host(struct ma_dev *ma_dev, 
+ struct usb_device *dev); 
+struct mausb_host_ep *mausb_find_ep_by_desc( 
+ const struct usb_endpoint_descriptor *ep_desc, 
+ struct mausb_dev *mausb_dev); 
+struct mausb_host_ep *mausb_find_ep_by_address(u8 address, 
+ struct mausb_dev *mausb_dev); 
+struct mausb_urb *mausb_alloc_maurb(struct mausb_host_ep *ma_ep, 
+ gfp_t memflags); 
+int mausb_internal_drop_maurb(struct mausb_urb *maurb, struct mausb_hcd *mhcd); 
+void init_ep_state(struct mausb_ep_state *state, u32 buf_size); 
+int mausb_activate_endpoints(struct mausb_dev *mausb_dev); 
+void mausb_link_ma_ep_to_usb_ep(struct mausb_host_ep *ma_ep, 
+ struct usb_ep *dev_ep); 
+struct mausb_gadget_ep *usb_ep_to_mausb_gadget_ep(struct usb_ep *ep); 
+int mausb_internal_add_ep(struct mausb_dev *ma_dev, 
+ struct usb_host_endpoint *ep, struct usb_ep *dev_ep, 
+ struct mausb_host_ep **mausb_ep, 
+ int (*transfer_timeout)(void *data), gfp_t memflags); 
+int mausb_internal_drop_ep(struct mausb_host_ep *ma_ep); 
+int mausb_update_ep(struct mausb_host_ep *ma_ep, 
+ struct mausb_ep_des *ma_ep_des); 
+struct mausb_dev *mausb_internal_alloc_dev(struct ma_dev *ma_dev, 
+ struct usb_device *dev, struct usb_gadget *gadget); 
+int mausb_internal_free_dev(struct ma_dev *ma_dev, 
+ struct mausb_dev *mausb_dev); 
+int mausb_internal_reset_ma_dev(struct ma_dev *ma_dev, __u8 ma_dev_addr, 
+ __u8 mass_id, struct mausb_hcd *mhcd, struct mausb_udc *maudc); 
+int mausb_init_ma_device(struct ma_dev *ma_dev, __u8 ma_dev_addr, __u8 mass_id, 
+ struct mausb_hcd *mhcd, struct mausb_udc *maudc, 
+ int (*req_switch)(struct mausb_mgmt_pkt *req, 
+ struct mausb_mgmt_pkt *resp, struct mausb_mgmt *mgmt), 
+ int (*device_connect)(int)); 
+int mausb_init_mgmt(struct mausb_mgmt *mgmt, spinlock_t *ma_dev_lock, 
+ int (*req_switch)(struct mausb_mgmt_pkt *req, 
+ struct mausb_mgmt_pkt *resp, struct mausb_mgmt *mgmt)); 
+const struct usb_endpoint_descriptor *mausb_get_ep_des( 
+ struct mausb_host_ep *ma_ep); 
+ 
+#endif 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_mem-host.c linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_mem-host.c
